Package de.willuhn.jameica.hbci.server

# Class AddressbookServiceImpl

java.lang.Object
java.rmi.server.RemoteObject
java.rmi.server.RemoteServer
java.rmi.server.UnicastRemoteObject
de.willuhn.jameica.hbci.server.AddressbookServiceImpl

All Implemented Interfaces:
  `de.willuhn.datasource.Service`, `Addressbook`, `AddressbookService`, `Serializable`, `Remote`

public class AddressbookServiceImpl extends UnicastRemoteObject implements AddressbookService
Implementierung des Adressbuch-Services.

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class java.rmi.server.RemoteObject

`ref`

## Constructor Summary

Constructors
Constructor
Description
`AddressbookServiceImpl()`
ct.

## Method Summary

Modifier and Type
Method
Description
`Address`
`contains(Address address)`
Die Funktion liefert die erste gefundene Adresse aus den Adressbuechern.
`List`
`findAddresses(String text)`
Sucht nach Adressen und liefert die gefundenen zurueck.
`Addressbook[]`
`getAddressbooks()`
Liefert die Liste aller gefundenen Adressbuecher.
`String`
`getName()`
Liefert einen sprechenden Namen fuer das Adressbuch.
`boolean`
`hasExternalAddressbooks()`
Liefert true, wenn neben dem Hibiscus-eigenen Adressbuch noch weitere gefunden wurden.
`boolean`
`isStartable()`
`boolean`
`isStarted()`
`void`
`start()`
`void`
`stop(boolean arg0)`

### Methods inherited from class java.rmi.server.UnicastRemoteObject

`clone, exportObject, exportObject, exportObject, exportObject, exportObject, unexportObject`

### Methods inherited from class java.rmi.server.RemoteServer

`getClientHost, getLog, setLog`

### Methods inherited from class java.rmi.server.RemoteObject

`equals, getRef, hashCode, toString, toStub`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AddressbookServiceImpl

public AddressbookServiceImpl() throws RemoteException
ct.

Throws:
  `RemoteException`

## Method Details

### findAddresses

public List findAddresses(String text) throws RemoteException
Description copied from interface: `Addressbook`
Sucht nach Adressen und liefert die gefundenen zurueck. Es ist der jeweiligen Implementierung des Adressbuches ueberlassen, in welchen Feldern/Attributen der Adressdaten sie nach dem uebergebenen Text sucht. Wird kein Text uebergeben, kann das Adressbuch selbst entscheiden, ob es alle Adressen zurueckliefert oder gar keine.

Specified by:
  `findAddresses` in interface `Addressbook`
Parameters:
  `text` - der Suchtext.
Returns:
  Liste der gefundenen Adressen. Die Objekte der Liste muessen vom Typ `Address` sein. Die Funktion darf auch `null` zurueckliefern, wenn keine Adressen gefunden wurden.
Throws:
  `RemoteException`
See Also:
  - `Addressbook.findAddresses(java.lang.String)`

### contains

public Address contains(Address address) throws RemoteException
Die Funktion liefert die erste gefundene Adresse aus den Adressbuechern. Falls die Adresse in mehreren Adressbuechern existiert, aus welchem der Adressbuecher die Adresse verwendet wird. Die Funktion sollte daher nur verwendet werden, um ueberhaupt festzustellen, ob die Adresse existiert.

Specified by:
  `contains` in interface `Addressbook`
Parameters:
  `address` - die gesuchte Adresse.
Returns:
  die Adresse mit den gleichen Eigenschaften aus dem Adressbuch oder `null`.
Throws:
  `RemoteException`
See Also:
  - `Addressbook.contains(de.willuhn.jameica.hbci.rmi.Address)`

### getAddressbooks

public Addressbook[] getAddressbooks() throws RemoteException
Description copied from interface: `AddressbookService`
Liefert die Liste aller gefundenen Adressbuecher.

Specified by:
  `getAddressbooks` in interface `AddressbookService`
Returns:
  Liste der Adressbuecher. Die Funktion liefert niemals `null` und auch nie ein leeres Array. Denn da `AddressbookService` selbst ebenfalls das `Addressbook`-Interface implementiert, wird mindestens dieses zurueckgeliefert. Allerdings wuerde es in diesem Fall keine Adressen finden, da ja keine tatsaechlichen "Backend"-Adressbuecher existieren. Zumindest das Hibiscus-eigene Adressbuch sollte aber immer enthalten sein.
Throws:
  `RemoteException`
See Also:
  - `AddressbookService.getAddressbooks()`

### hasExternalAddressbooks

public boolean hasExternalAddressbooks() throws RemoteException
Description copied from interface: `AddressbookService`
Liefert true, wenn neben dem Hibiscus-eigenen Adressbuch noch weitere gefunden wurden. In diesem Fall koennte dem Benutzer z.Bsp. ein Auswahl-Dialog angezeigt werden, in dem er das gewuenschte Adressbuch auswaehlen kann.

Specified by:
  `hasExternalAddressbooks` in interface `AddressbookService`
Returns:
  true, wenn weitere Adressbuecher existieren.
Throws:
  `RemoteException`
See Also:
  - `AddressbookService.hasExternalAddressbooks()`

### getName

public String getName() throws RemoteException
Description copied from interface: `Addressbook`
Liefert einen sprechenden Namen fuer das Adressbuch.

Specified by:
  `getName` in interface `Addressbook`
Specified by:
  `getName` in interface `de.willuhn.datasource.Service`
Returns:
  Name des Adressbuches.
Throws:
  `RemoteException`
See Also:
  - `Service.getName()`

### isStartable

public boolean isStartable() throws RemoteException

Specified by:
  `isStartable` in interface `de.willuhn.datasource.Service`
Throws:
  `RemoteException`
See Also:
  - `Service.isStartable()`

### isStarted

public boolean isStarted() throws RemoteException

Specified by:
  `isStarted` in interface `de.willuhn.datasource.Service`
Throws:
  `RemoteException`
See Also:
  - `Service.isStarted()`

### start

public void start() throws RemoteException

Specified by:
  `start` in interface `de.willuhn.datasource.Service`
Throws:
  `RemoteException`
See Also:
  - `Service.start()`

### stop

public void stop(boolean arg0) throws RemoteException

Specified by:
  `stop` in interface `de.willuhn.datasource.Service`
Throws:
  `RemoteException`
See Also:
  - `Service.stop(boolean)`